{Nokia knockoff driver
Based off of Bean's BS2 code for the LCD and Martin Hebel's SHIFTOUT routine}
CON
' _clkmode = xtal1 + pll16x
' _xinfreq = 5_000_000

    #0,MSBPRE,LSBPRE,MSBPOST,LSBPOST                                           'Used for SHIFTIN routines
    #4,LSBFIRST,MSBFIRST                                                       'Used for SHIFTOUT routines


#6, CS, SClock, SData, Reset         'Pin assignments
    '#4,LSBFIRST,MSBFIRST                                                       'Used for SHIFTOUT routines

 'LSBFIRST = 0
 'MSBFIRST = 1

'VAR     long          DataValue

Obj
  SPIr  :       "SPIEngine"
PUB godemo | i
InitLCD
  CLS
  repeat
    repeat i from 0 to 4096
      DrawH(0,0,i)
      DrawE(6,0,i)
      DrawL(12,0,i)
      DrawL(18,0,i)
      DrawO(24,0,i)
  

PUB go | i, j
'SendCommand($25)
'InitLCD
  Cls
  repeat j from 0 to 129                                              
    repeat i from 0 to 129
      plot(i,j,i+(j*2))
  'repeat 

PUB DrawE(x,y,c)
  plot(x,y,c)
  plot(x,y+1,c)
  plot(x,y+2,c)
  plot(x,y+3,c)
  plot(x,y+4,c)
  plot(x,y+5,c)
  plot(x,y+6,c)
  plot(x+1,y,c)
  plot(x+2,y,c)
  plot(x+3,y,c)
  plot(x+4,y,c)
  plot(x+1,y+3,c)
  plot(x+2,y+3,c)
  'plot(x+3,y+3,c)
  'plot(x+4,y+3,c)
  plot(x+1,y+6,c)
  plot(x+2,y+6,c)
  plot(x+3,y+6,c)
  plot(x+4,y+6,c)
PUB DrawH(x,y,c)
  plot(x,y,c)
  plot(x,y+1,c)
  plot(x,y+2,c)
  plot(x,y+3,c)
  plot(x,y+4,c)
  plot(x,y+5,c)
  plot(x,y+6,c)
  plot(x+4,y,c)
  plot(x+4,y+1,c)
  plot(x+4,y+2,c)
  plot(x+4,y+3,c)
  plot(x+4,y+4,c)
  plot(x+4,y+5,c)
  plot(x+4,y+6,c)
  plot(x+1,y+3,c)
  plot(x+2,y+3,c)
  plot(x+3,y+3,c)

PUB DrawL(x,y,c)
  plot(x,y,c)
  plot(x,y+1,c)
  plot(x,y+2,c)
  plot(x,y+3,c)
  plot(x,y+4,c)
  plot(x,y+5,c)
  plot(x,y+6,c)
  plot(x+1,y+6,c)
  plot(x+2,y+6,c)
  plot(x+3,y+6,c)
  plot(x+4,y+6,c)

PUB DrawO(x,y,c)
  plot(x+1,y,c)
  plot(x+2,y,c)
  plot(x+3,y,c)

  plot(x,y+1,c)
  plot(x+4,y+1,c)
  plot(x,y+2,c)
  plot(x+4,y+2,c)
  plot(x,y+3,c)
  plot(x+4,y+3,c)
  plot(x,y+4,c)
  plot(x+4,y+4,c)
  plot(x,y+5,c)
  plot(x+4,y+5,c)
  plot(x+1,y+6,c)
  plot(x+2,y+6,c)
  plot(x+3,y+6,c)
                          
PUB Plot(x,y,c)
  SendCommand($75)
  SendData(y+2)
  SendData(131)
  SendCommand($15)
  SendData(x)
  SendData(129)
  SendCommand($5C)
  SendData(c)

PUB Cls | i
  Plot(0,0,0)
  repeat i from 1 to 16899
    SendData(0)

PUB SendCommand(cmd)
  'waitcnt(1 + cnt)
  SPIr.SHIFTOUT(SData, SClock, MSBFIRST, 9, cmd)
  'SPIr.SHIFTOUT(SData, SClock, MSBFIRST, 9, $25)
  'SHIFTOUT(SData, SClock, MSBFIRST, 9, cmd)
  'SendData(cmd)
PUB SendSpcCommand(cmd)
  SHIFTOUT(SData, SClock, MSBFIRST, 9, cmd)
PUB SendData(data)
  'waitcnt(22 + cnt)
  SPIr.SHIFTOUT(SData, SClock, MSBFIRST, 9, data | $100)
  'SHIFTOUT(SData, SClock, MSBFIRST, 9, data | $100)

PUB SHIFTOUT (Dpin, Cpin, Mode, Bits, Value)| bitNum
{{
   Shift data out, master clock, for mode use ObjName#LSBFIRST, #MSBFIRST
   Clock rate is ~16Kbps.  Use at 80MHz only is recommended.
     BS2.SHIFTOUT(5,6,"B",BS2#LSBFIRST,8)
}}
    outa[Dpin]:=0                                          ' Data pin = 0
    dira[Dpin]~~                                           ' Set data as output
    outa[Cpin]:=0
    dira[Cpin]~~

    If Mode == LSBFIRST                                    ' Send LSB first    
       REPEAT Bits
          outa[Dpin] := Value                              ' Set output
          Value := Value >> 1                              ' Shift value right
          !outa[Cpin]                                      ' cycle clock
          !outa[Cpin]
          waitcnt(1000 + cnt)                              ' delay

    elseIf Mode == MSBFIRST                                ' Send MSB first               
       REPEAT Bits                                                                
          outa[Dpin] := Value >> (bits-1)                  ' Set output           
          Value := Value << 1                              ' Shift value right    
          !outa[Cpin]                                      ' cycle clock          
          !outa[Cpin]                                                             
          waitcnt(1000 + cnt)                              ' delay                
    outa[Dpin]~                                            ' Set data to low

PUB InitLCD | i
  dira[CS]~~
  dira[SClock]~~
  dira[SData]~~
  dira[Reset]~~
  outa[CS]~~
  waitcnt(clkfreq/100 + cnt)
  outa[SClock]~~
  outa[SData]~
  outa[Reset]~
  waitcnt(clkfreq/1000 + cnt)
  outa[Reset]~~
  waitcnt(clkfreq/50 + cnt)
  outa[CS]~
  'outa[Reset]:=0
  'outa[Reset]:=1
  SendSpcCommand($00)           'Here it is.  This first command has to be issued by the slow shiftout
                                'routines, and everything else after it works with the faster SPI code.
                                'Dunno why, maybe a fresh mind can figure it out.
  SendCommand($CA)              '11001010
  'SendData($03)          
  SendData($00)                 '00000000
  SendData(32)                  '00100000
  SendData(12)                  '00001100
  'SendData($00)                'What's this here for?  $CA only has 3 params listed in documentation.
  SendCommand($BB)              '10111011
  SendData($01)                 '00000001
  SendCommand($D1)              '11010001
  SendCommand($94)
  SendCommand($81)
  SendData(191)
  SendData($01)
  SendCommand($20)
  SendData($0F)
  waitcnt(clkfreq/10 + cnt)
  SendCommand($A7)
  SendCommand($BC)
  SendData($00)
  SendData(0)
  SendData($01)
  SendData($00)
  SendCommand($CE)
  SendData(0)
  SendData(2)
  SendData(6)
  SendData(8)
  SendData(10)
  SendData(12)
  SendData(15)                                   
  SendData(0)
  SendData(2)
  SendData(4)
  SendData(6)
  SendData(8)
  SendData(10)
  SendData(12)
  SendData(15)
  SendData(0)
  SendData(5)
  SendData(10)
  SendData(15)
  SendCommand($25)
  SendCommand($AF)
  'waitcnt(clkfreq/5 + cnt)
  'repeat i from 0 to 180       'Removed this, set it directly in $81 first param 191 above.
    'SendCommand($D6)